﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            DropDownProvider provider = new DropDownProvider();
            provider.ID = "dropdown1";
            provider.EditorControl.DropDownContainerWidth = 150;
            WebDataGrid1.EditorProviders.Add(provider);
        }

       ((DropDownProvider) WebDataGrid1.EditorProviders["dropdown1"]).EditorControl.DataSource = populateGrid();
       ((DropDownProvider) WebDataGrid1.EditorProviders["dropdown1"]).EditorControl.TextField = "Name";
       ((DropDownProvider)WebDataGrid1.EditorProviders["dropdown1"]).EditorControl.ValueField = "Value";


        WebDataGrid1.DataSource = populateGrid();
        WebDataGrid1.DataBind();
    }


    //use to populate our WebDataGrid (and DropdownProvider for simplicity)
    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        dt.Columns.Add("Value");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row["Name"] = "Item " + i;
            row["Value"] = i;
            dt.Rows.Add(row);
        }

        return dt;
    }

    protected void WebDataGrid1_Init(object sender, EventArgs e)
    {
        //create an unbound column to associate the dropdown provider with (can be a bounddatafield if needed)
        UnboundField column = new UnboundField();
        column.Key = "dropdownCol";
        column.Header.Text = "Dropdown Column";

        //instantiate an editing core
        EditingCore core = new EditingCore();
        core.Enabled = true;
        core.AutoCRUD = false;

        CellEditing editing = new CellEditing();
        core.Behaviors.Add(editing);

        //create the column setting for the Dropdown Column
        EditingColumnSetting setting = new EditingColumnSetting();
        setting.ColumnKey = "dropdownCol";
        setting.EditorID = "dropdown1";

        editing.ColumnSettings.Add(setting);

        WebDataGrid1.Columns.Add(column);
        WebDataGrid1.Behaviors.Add(core);
    }
}